#!/usr/bin/php
<?php
/**
 * zForum Migration Script
 * This script patch migration from version 1.0.8 to 1.1.0 running on MySQL 4.1.x
 * @author Marcin F. Wisniowski <marcin.wisniowski@mfw.pl>
 * @version 1.0.0
 */
/////////////////////////////////////////////////////////////////////
// Configure Section
// Edit this variable to open MySQL DB connection
$db_host = 'localhost';
$db_user = 'mysql';
$db_pass = 'mysql';
$db_name = 'zforum';
$new_line_str = '<br />';
// Do not edit below this line if you don't know what are you doing
/////////////////////////////////////////////////////////////////////
$db_link = null;
/////////////////////////////////////////////////////////////////////
// Migration process starts here
connectToDB();
print $new_line_str.'DB Migration process starts'.$new_line_str;
// 1. Add cat_order field into zf_forum_category table and fill with default values
updateCategoryTable();
print 'Phase 1 - Update Category table: Done'.$new_line_str;
// 2. Split zf_topic table into zf_topics and zf_posts
createTopicsAndPostsTable();
splitTopicTable();
print 'Phase 2 - Split Topic table: Done'.$new_line_str;
// 3. Patch zf_forum table
patchForumTable();
print 'Phase 3 - Update forum table: Done'.$new_line_str;
// 4. Patch System properties
patchSystemProperies();
print 'Phase 4 - Add System Properties: Done'.$new_line_str;
// 5. Delete Table zf_topic (old-one)
deleteTopicTable();
print 'Phase 5 - Delete zf_topic table: Done'.$new_line_str;
closeConnectionToDB();
// Migration process ends
/////////////////////////////////////////////////////////////////////
function connectToDB() {
    global $db_host, $db_user, $db_pass, $db_name, $db_link;
    $db_link = @mysql_connect($db_host, $db_user, $db_pass) or die ('Can\'t connect to DB Server: ' . mysql_error());
    @mysql_select_db($db_name) or die ('Can\'t choose selected DB');
}
function closeConnectionToDB() {
	global $db_link;
	@mysql_close($db_link);
}
function runQuery($query) {
    global $db_link;
    $result = @mysql_query($query, $db_link) or die('Query failed: ' . @mysql_error());
    return $result;
}
function fetchAssoc($query_result) {
    return @mysql_fetch_array($query_result, MYSQL_ASSOC);
}
function updateCategoryTable() {
    $sql = 'ALTER TABLE `zf_forum_category` ADD `cat_order` INT(8) UNSIGNED DEFAULT "0" NOT NULL AFTER `cat_desc`';
    runQuery($sql);
    $sql = 'SELECT cat_id FROM `zf_forum_category`';
    $result = runQuery($sql);
    $order = 1;
    while ($line = fetchAssoc($result)) {
        $cat_id = $line['cat_id'];
        $sql = "UPDATE `zf_forum_category` SET `cat_order` = $order WHERE cat_id = $cat_id";
        $order++;
    }
}
function createTopicsAndPostsTable() {
    $sql = 'create table zf_topics ( topic_id int(11) unsigned not null primary key auto_increment,
                                     forum_id int(11) unsigned not null,
                                     topic_title varchar(255) not null,
                                     topic_desc varchar(255),
                                     creation_user varchar(40) not null,
                                     creation_date datetime not null,
                                     topic_views int(8) unsigned not null default 0,
                                     topic_replies int(8) unsigned not null default 0,
                                     topic_first_post_id int(11) unsigned not null default 0,
                                     topic_last_post_id int(11) unsigned not null default 0,
                                     locked_flag int(1) unsigned not null default 0,
                                     disabled_flag int(1) unsigned not null default 0,
                                     sticky_flag int(1) unsigned not null default 0,
                                     poll_flag int(1) unsigned not null default 0,
                                     system_announcement_flag int(1) unsigned not null default 0,
                                     index forum_id(forum_id),
                                     index system_announcement_flag(system_announcement_flag) )';
    runQuery($sql);
    $sql = 'create table zf_posts ( post_id int(11) unsigned not null primary key auto_increment,
                                    topic_id int(11) unsigned not null,
                                    content text not null,
                                    creation_user varchar(40) not null,
                                    creation_date datetime not null,
                                    modifying_user varchar(40) not null,
                                    modifying_date datetime not null,
                                    ip_address varchar(15),
                                    index topic_id(topic_id) )';
    runQuery($sql);
}
function parseContent($cont) {
    $cont = str_replace('[blockquote]', '[quote]', $cont);
    $cont = str_replace('[/blockquote]', '[/quote]', $cont);
    $cont = parseUrlTags($cont);
    return $cont;
}
function parseUrlTags($cont) {
    while ((substr($cont,0,5) == '[url=' || strpos($cont, '[url=') != null )&& strpos($cont, '][/url]') != null) {
        $tag_start = strpos($cont, '[url=');
        $tag_end   = strpos($cont, '][/url]') + strlen('][/url]');
        $base_url_starts = strpos($cont, '[url=') + strlen('[url=');
        $base_url_ends = strpos($cont, ' urltitle=');
        $label_starts = strpos($cont, ' urltitle=') + strlen(' urltitle=');
        $label_ends = strpos($cont, '][/url]');
        $base_url = substr($cont, $base_url_starts, $base_url_ends-$base_url_starts);
        $label = substr($cont, $label_starts, $label_ends-$label_starts);
        if (substr($base_url, 0, 7) != 'http://')
            $base_url = "http://".$base_url;
        $new_tag = '[url label="'.$label.'"]'.$base_url.'[/url]';
        $cont = substr($cont, 0, $tag_start).$new_tag.substr($cont, $tag_end);
    }
    return $cont;
}

function splitTopicTable() {
    $sql = 'SELECT * FROM `zf_topic` WHERE parent_flag = 1';
    $result = runQuery($sql);
    $topic_id = 1;
    $post_id = 1;
    while ($line = fetchAssoc($result)) {
        $sql = "INSERT INTO `zf_topics` (`topic_id`, `forum_id`, `topic_title`, `creation_user`, `creation_date`, `topic_views`, `topic_replies`, `topic_first_post_id`, `topic_last_post_id`, `locked_flag`, `disabled_flag`, `sticky_flag`, `poll_flag`, `system_announcement_flag`) VALUES ($topic_id, '".$line['forum_id']."', '".$line['title']."', '".$line['creation_user']."', '".$line['creation_date']."', '".$line['hits']."', '0', '$post_id', '0', '".$line['locked_flag']."', '".$line['disabled_flag']."', '".$line['sticky_flag']."', '".$line['poll_flag']."', '".$line['system_announcement_flag']."')";
        runQuery($sql);
        $sql = "SELECT * FROM `zf_topic` WHERE parent_id = '".$line['topic_id']."'";
        $posts = runQuery($sql);
        $first = $post_id;
        $content = parseContent($line['content']);
        $sql = "INSERT INTO `zf_posts` (`post_id`, `topic_id`, `content`, `creation_user`, `creation_date`, `modifying_user`, `modifying_date`, `ip_address`) VALUES ($post_id, $topic_id, '$content', '".$line['creation_user']."', '".$line['creation_date']."', '".$line['modifying_user']."', '".$line['modifying_date']."', '".$line['ip_address']."')";
        runQuery($sql);
        $post_id++;
        $replies = 0;
        while ($post = fetchAssoc($posts)) {
            $content = parseContent($post['content']);
            $sql = "INSERT INTO `zf_posts` (`post_id`, `topic_id`, `content`, `creation_user`, `creation_date`, `modifying_user`, `modifying_date`, `ip_address`) VALUES ($post_id, $topic_id, '$content', '".$post['creation_user']."', '".$post['creation_date']."', '".$post['modifying_user']."', '".$post['modifying_date']."', '".$post['ip_address']."')";
            runQuery($sql);
            $last = $post_id;
            $post_id++;
            $replies++;
        } 
        $sql = "UPDATE `zf_topics` SET `topic_replies` = $replies,`topic_last_post_id` = $last WHERE `topic_id` = $topic_id LIMIT 1" ;
        runQuery($sql);
        $topic_id++;
    }
}
function patchForumTable() {
    $sql = 'ALTER TABLE `zf_forum` ADD `forum_topics` INT(11) UNSIGNED DEFAULT 0 NOT NULL AFTER `forum_desc`, ADD `forum_posts` INT(11) UNSIGNED DEFAULT 0 NOT NULL AFTER `forum_topics`, ADD `forum_views` INT(11) UNSIGNED DEFAULT 0 NOT NULL AFTER `forum_posts`, ADD `forum_last_post_id` INT(11) UNSIGNED DEFAULT 0 NOT NULL AFTER `forum_views`, ADD `forum_order` INT(8) UNSIGNED DEFAULT 0 NOT NULL AFTER `forum_last_post_id`';
    runQuery($sql);
    $sql = 'SELECT cat_id FROM `zf_forum_category`';
    $result = runQuery($sql);
    while ($line = fetchAssoc($result)) {
        $cat_id = $line['cat_id'];
        $sql = "SELECT * FROM `zf_forum` WHERE cat_id = $cat_id";
        $forums = runQuery($sql);
        $order = 1;
        while ($forum = fetchAssoc($forums)) {
            $forum_id = $forum['forum_id'];
            $sql = "SELECT sum(topic_views) AS 'views', sum(topic_replies) AS 'replies', count(topic_id) AS 'topics' FROM `zf_topics` WHERE forum_id=$forum_id";
            $res = runQuery($sql);
            $stats = fetchAssoc($res);
            $sql = "SELECT zp.post_id FROM zf_topics AS zt, zf_posts AS zp WHERE zt.forum_id = $forum_id AND zt.topic_last_post_id = zp.post_id ORDER BY zp.modifying_date desc LIMIT 1";
            $res = runQuery($sql);
            $last = fetchAssoc($res);
            $forum_posts = $stats['replies'] + $stats['topics'];
            $sql = "UPDATE `zf_forum` SET `forum_order` = '$order', `forum_last_post_id` = '".$last['post_id']."', `forum_views` = '".$stats['views']."', `forum_topics` = '".$stats['topics']."', `forum_posts` = '$forum_posts' WHERE forum_id = $forum_id";
            runQuery($sql);
            $order++;
        }
    }    
}
function patchSystemProperies() {
    $sql = "insert into `zf_system_properties` (property_name, property_desc, property_value) values ('zfsp_preview_topics_limit', 'Last Responses in topic preview mode: Controls the amount of responses (posts) that zForum will show, 0 is unlimited', 5)";
    runQuery($sql); 
    $sql = "insert into `zf_system_properties` (property_name, property_desc, property_value) values ('zfsp_labeled_links', 'Switch between \"Simple\" and \"Labeled\" links in add post wizard and parser, to activate Labeled links type Yes', '')";
    runQuery($sql);
    $sql = "insert into `zf_system_properties` (property_name, property_desc, property_value) values ('zfsp_show_ip', 'To show poster IP address to public type Yes', '')";
    runQuery($sql);
    $sql = "insert into `zf_system_properties` (property_name, property_desc, property_value) values ('zfsp_nested_quotes', 'To allow reply with nested quotes type Yes', 'Yes')";
    runQuery($sql);
    $sql = "insert into `zf_system_properties` (property_name, property_desc, property_value) values ('zfsp_show_wizards', 'To show wizards used to compose post message type Yes', 'Yes')";
    runQuery($sql);    
}
function deleteTopicTable() {
    $sql = 'DROP TABLE `zf_topic`';
    runQuery($sql);
}

?>